<?php
/******************************************************************************************
 * The contents of this file are subject to the SOURCE CODE AGREEMENT ("License Agreement")
 * which can be viewed at http://www.letrium.com/jetmobile-agreement
 *
 * BY DOWNLOADING AND/OR INSTALLING AND/OR USING THIS FILE YOU AGREE TO BE BOUND BY THE TERMS
 * OF THIS LICENSE AGREEMENT. IF YOU DO NOT AGREE TO THE TERMS OF THIS LICENSE AGREEMENT,
 * PLEASE DO NOT DOWNLOAD, INSTALL, RUN, OR OTHERWISE USE THE SOURCES OF THE SOFTWARE.
 * Under the terms of the license, You shall not, among other things:
 * 1) permit, authorize, license or sublicense any third party to view or use
 * the Source Code; 2) sell, rent, lease, distribute, make available, publish or
 * otherwise transfer the Source Code; 3) develop Forked Software;
 * 4) use the Source Code for anything other than its intended, legitimate,
 * and legal purpose.
 *
 * You do not have the right to remove Letrium copyrights from the source code
 * or user interface.
 *
 * To the maximum extent permitted by applicable law, Letrium shall not be liable
 * to Licensee for any incidental, consequential, special, punitive or
 * indirect damages, including without limitation, damages for loss of profits,
 * business opportunity, data or use, incurred by Licensee or any third party,
 * even if it has been advised of the possibility of such damages.
 * Letrium makes no representations or warranties with respect to the Source Code.
 * All express or implied representations and warranties, including without
 * limitation any implied warranty of merchantability, of fitness for a particular
 * purpose, of reliability or availability, of accuracy or completeness of responses,
 * of results, of workmanlike effort, of lack of viruses, and of lack of negligence,
 * is hereby expressly disclaimed. Licensee specifically acknowledges that the Source Code
 * is provided "as is" and may have bugs, errors, defects or deficiencies.
 *
 * Copyright (C) 2012 Letrium ltd.; All Rights Reserved.
 ******************************************************************************************/

function CheckFileAccess($url) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0'); 
	curl_setopt($ch, CURLOPT_HEADER, TRUE);
	curl_setopt($ch, CURLOPT_NOBODY, TRUE); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE); 

	$exe = curl_exec($ch);
	if (!curl_errno($ch)) {
		$info = curl_getinfo($ch);	
		if ($info['http_code'] == '403' || $info['http_code'] == '500') {
			curl_close($ch); 
			return false;
		}
	} else {
	  curl_close($ch); 
	  return false;
	} 

    curl_close($ch); 
	return true;
}

function post_install() {
		
	require_once('modules/Configurator/Configurator.php');		
	
	$configurator = new Configurator();
	if (SugarConfig::getInstance()->get('mobile_settings.modules', false) == false) {
		$modules = "Accounts;Contacts;Leads;Opportunities;Calendar;Meetings;Calls;Tasks;Notes";
		$configurator->config['mobile_settings']['modules'] = $modules;
	} else {
		$modules = SugarConfig::getInstance()->get('mobile_settings.modules');
	}
	
	$configurator->config['mobile_settings']['api_path'] = 'service/jetMobile/rest.php';
	$configurator->config['mobile_settings']['js_caching'] = true;
	$configurator->config['mobile_settings']['template_caching'] = true;
	$configurator->config['mobile_settings']['name'] = 'Jet Mobile';	
	$configurator->handleOverride();
	$configurator->clearCache();
	
	
	    
	$url = $_SERVER['HTTP_HOST'];
	$path = preg_replace('/\?.*$/', '', $_SERVER['REQUEST_URI']);
	if (!empty($path)) {
		$url .= "/" . ltrim(dirname($path), '/');
	}
	$url = rtrim($url, '/');
	if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != "off") {
		$url = 'https://' . $url;
	} else {
		$url = 'http://' . $url;
	}
	$siteUrl = $url;    
	$jetUrl = $siteUrl . "/m";	
		
	$permissions = array(
		array(
			'dir' => 0755,
			'file' => 0644
		),
		array(
			'dir' => 0775,
			'file' => 0664
		),
	);

	if (function_exists('curl_init') && !is_windows()) {
		if (!CheckFileAccess("{$siteUrl}/service/jetMobile/rest.php")) {
			foreach ($permissions as $val) {
				chmod("service/", $val['dir']);
				chmod("service/jetMobile/", $val['dir']);
				chmod("service/jetMobile/rest.php", $val['file']);
				if (CheckFileAccess("{$siteUrl}/service/jetMobile/rest.php")) {
					break;
				}		
			}
		}
		if (!CheckFileAccess("{$siteUrl}/m/")) {
			foreach ($permissions as $val) {
				chmod("m/", $val['dir']);
				chmod("m/index.html", $val['file']);
				if (CheckFileAccess("{$siteUrl}/m/")) {
					break;
				}
			}
		}

	}	
	
	$text = "
		<div style=\"font-size: 15px; padding: 10px 0;\">
	";
	
	$text .= "
		<p>You have installed Lite version of Jet Mobile. 
		Information about Pro version is available on <a href=\"http://letrium.com/jetmobile\">the product page</a>.</p>
	";
	
	$text .= "
		<p>Jet Mobile application now is available by the link <b><a href=\"".$jetUrl."\">".$jetUrl . "</a></b></p>
		</div>
	";	
	echo $text;
	
}
